<?php
/*
Plugin Name: SMP Smart Link
Plugin URI: http://socialmobilepress.com/
Description: Social Mobile Press Smart Link Plugin.
Version: 1.2
Author: Joe Veloz
Author URI: http://socialmobilepress.com/
*/

register_activation_hook(__FILE__, 'mq_create_db_smart_link');

//add_action('init','mq_create_db_smart_link');

function mq_create_db_smart_link(){
	global $wpdb;

	$table_name = $wpdb->prefix . "smart_link";

	$sql="create table ".$table_name."(id bigint(9) NOT NULL AUTO_INCREMENT PRIMARY KEY,title VARCHAR(255),fb_link VARCHAR(255),mobile_link VARCHAR(255),smart_link VARCHAR(255),cur_timestamp TIMESTAMP)";
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	
	$wpdb->query($sql);
}

function smartlink_register_my_custom_menu_page(){
	add_menu_page( 'Smart Link', 'Smart Link', 'manage_options', 'smart_link_redirect', 'smart_link_show_settings', plugins_url( 'smart-link/images/favicon.png' ), 6 );
}

function smart_link_show_settings(){
	if(isset($_POST)){
		smart_link_processdata();
	}

	require_once('smart_link_template.php');
}

function smart_link_processdata(){
	$action=isset($_POST['action'])?$_POST['action']:(isset($_GET['action'])?$_GET['action']:'');
	switch(@$action){
		case 'savenewlink':
			smart_link_savenewlink();
		break;

		case 'delete';
			smart_link_delete();
		break;
	}
}

function smart_link_delete(){
	global $wpdb;

	$table_name = $wpdb->prefix . "smart_link";

	$wpdb->query( 
		$wpdb->prepare( 
			"DELETE FROM $table_name
			 WHERE id = %d
			",
		        $_GET['id'] 
	        )
	);

	smart_link_set_msg("Record deleted successfully!");
	smart_link_redirect(get_admin_url()."?page=".$_GET['page']);
}

function smart_link_isSmartLinkExist($smartlink){
	global $wpdb;

	$table_name = $wpdb->prefix . "smart_link";

	$myrows = $wpdb->get_results( "SELECT * FROM ".$table_name." where smart_link='".$smartlink."'" );

	if(count($myrows)>0){
		return true;
	}else{
		return false;
	}
}

function smart_link_savenewlink(){
	global $wpdb;
	

	$error=array();

	if(strlen($_POST['link_title'])==0){
		$error[]='Please provide title.';
	}

	if(strlen($_POST['fb_link'])==0){
		$error[]='Please provide FB link.';
	}

	if(strlen($_POST['mobile_link'])==0){
		$error[]='Please provide Mobile link.';
	}

	if(strlen($_POST['smart_link'])>0){
		if(strlen($_POST['id'])==0){
			if(smart_link_isSmartLinkExist($_POST['smart_link'])){
				$error[]='Smart link already exist.';
			}else{
				
			}
		}
	}

	if(count($error)>0){
		smart_link_set_msg(implode("<br />",$error));

		smart_link_redirect(get_admin_url()."?page=".$_GET['page']);
	}else{
		if((strlen($_POST['id'])==0)):

		$table_name = $wpdb->prefix . "smart_link";
		$sql="insert into ".$table_name." set title='".$_POST['link_title']."',fb_link='".$_POST['fb_link']."',mobile_link='".$_POST['mobile_link']."'";
		$result=$wpdb->insert(
				$table_name,
				array(
					'title'=>$_POST['link_title'],
					'fb_link'=>$_POST['fb_link'],
					'mobile_link'=>$_POST['mobile_link']
				),
				array(
					'%s',
					'%s',
					'%s'
				)
			);

		$id=$wpdb->insert_id;

		if(isset($_POST['smart_link'])){
			$smartlink=$_POST['smart_link'];
		}else{
			$smartlink=smart_link_alphaID($id,false,4);
		}

		

		$wpdb->update(
				$table_name,
				array(
					'smart_link'=>$smartlink
				),
				array('id'=>$id),
				array(
					'%s'
				),
				array('%d')
			);

		smart_link_set_msg("Smart link created successfully!");
		smart_link_redirect(get_admin_url()."?page=".$_GET['page']);

		else:
			$id=$_POST['id'];

			$table_name = $wpdb->prefix . "smart_link";

			$wpdb->update(
				$table_name,
				array(
					'title'=>$_POST['link_title'],
					'fb_link'=>$_POST['fb_link'],
					'mobile_link'=>$_POST['mobile_link']
				),
				array('id'=>$id),
				array(
					'%s',
					'%s',
					'%s'
				),
				array('%d')
			);

			smart_link_set_msg("Record updated successfully!");
			smart_link_redirect(get_admin_url()."?page=".$_GET['page']);
		endif;
	}


}

function smart_link_alphaID($in, $to_num = false, $pad_up = false, $passKey = null)
{
  $index = "abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  if ($passKey !== null) {
      // Although this function's purpose is to just make the
      // ID short - and not so much secure,
      // with this patch by Simon Franz (http://blog.snaky.org/)
      // you can optionally supply a password to make it harder
      // to calculate the corresponding numeric ID

      for ($n = 0; $n<strlen($index); $n++) {
          $i[] = substr( $index,$n ,1);
      }

      $passhash = hash('sha256',$passKey);
      $passhash = (strlen($passhash) < strlen($index))
          ? hash('sha512',$passKey)
          : $passhash;

      for ($n=0; $n < strlen($index); $n++) {
          $p[] =  substr($passhash, $n ,1);
      }

      array_multisort($p,  SORT_DESC, $i);
      $index = implode($i);
  }

  $base  = strlen($index);

  if ($to_num) {
      // Digital number  <<--  alphabet letter code
      $in  = strrev($in);
      $out = 0;
      $len = strlen($in) - 1;
      for ($t = 0; $t <= $len; $t++) {
          $bcpow = bcpow($base, $len - $t);
          $out   = $out + strpos($index, substr($in, $t, 1)) * $bcpow;
      }

      if (is_numeric($pad_up)) {
          $pad_up--;
          if ($pad_up > 0) {
              $out -= pow($base, $pad_up);
          }
      }
      $out = sprintf('%F', $out);
      $out = substr($out, 0, strpos($out, '.'));
  } else {
      // Digital number  -->>  alphabet letter code
      if (is_numeric($pad_up)) {
          $pad_up--;
          if ($pad_up > 0) {
              $in += pow($base, $pad_up);
          }
      }

      $out = "";
      for ($t = floor(log($in, $base)); $t >= 0; $t--) {
          $bcp = bcpow($base, $t);
          $a   = floor($in / $bcp) % $base;
          $out = $out . substr($index, $a, 1);
          $in  = $in - ($a * $bcp);
      }
      $out = strrev($out); // reverse
  }

  return $out;
}

function smart_link_redirect($link){
	?>
	<script type="text/javascript">
	window.location='<?php echo $link; ?>';
	</script>
	<?php
	die;
}

function smart_link_set_msg($msg){
	

	$_SESSION['smart_link_flash']="<div class='smart_link_message'>".$msg."</div>";
}

function smart_link_get_msg(){
	if(!session_id()) {
        session_start();
    }

	$msg=@$_SESSION['smart_link_flash'];
	unset($_SESSION['smart_link_flash']);

	return $msg;
}

add_action( 'admin_menu', 'smartlink_register_my_custom_menu_page' );
add_action('init', 'smart_link_myStartSession', 1);

function smart_link_myStartSession() {
    if(!session_id()) {
        session_start();
    }


}

add_action( 'template_redirect', 'smart_link_template_redirect_intercept' );
function smart_link_template_redirect_intercept() {
    global $wp_query;

    if( $wp_query->get('smart_link') ) {
        $someVar = $wp_query->get('smart_link');
        is_smart_link_exist($someVar);
        exit;
    }
}

function is_smart_link_exist($shortcode){
	global $wpdb;
	$table_name = $wpdb->prefix . "smart_link";

	$myrows = $wpdb->get_results( "SELECT * FROM ".$table_name." where smart_link='".$shortcode."'" );

	if(count($myrows)>0){
		if(wp_is_mobile()){
			wp_redirect($myrows[0]->mobile_link);
		}else{
			wp_redirect($myrows[0]->fb_link);
		}
		die;
	}
}

function my_plugin_add_rewrite_rules() {
    $rule = '^smart_link/([^/]*)/?$';
    add_rewrite_rule(
        $rule,
        'index.php?smart_link=$matches[1]',
        'top' );
}
 
add_action( 'init', 'my_plugin_rewrites_init' );
function my_plugin_rewrites_init() {
    add_rewrite_tag( '%smart_link%', '([0-9]+)' );
    add_rewrite_tag( '%post-id%', '([0-9]+)' );
    my_plugin_add_rewrite_rules();
}
 
register_activation_hook( __FILE__, 'my_plugin_activate' );
function my_plugin_activate() {
    global $wp_rewrite;
    my_plugin_add_rewrite_rules();
    $wp_rewrite->flush_rules();
}
?>