<?php
class Smart_link_list extends WP_List_Table {
	function get_columns(){
	  $columns = array(
	    'title' => 'Title',
	    'fb_link'    => 'Fb Link',
	    'mobile_link'      => 'Mobile Link',
	    'smart_link'=>'Smart Link'
	  );
	  return $columns;
	}

	function get_items(){
		global $wpdb;
		$table_name = $wpdb->prefix . "smart_link";
		$sql="select * from ".$table_name." order by id desc";
		$data=$wpdb->get_results($sql);

		$dt=array();

		for($i=0;$i<count($data);$i++){
			$dt[]=array('id'=>$data[$i]->id,'title'=>$data[$i]->title,'fb_link'=>$data[$i]->fb_link,'mobile_link'=>$data[$i]->mobile_link,'smart_link'=>$data[$i]->smart_link);
		}

		return $dt;
	}

	function column_title($item) {
	  $actions = array(
	            'edit'      => sprintf('<a href="?page=%s&action=%s&id=%s">Edit</a>',$_REQUEST['page'],'edit',$item['id']),
	            'delete'    => sprintf('<a href="?page=%s&action=%s&id=%s">Delete</a>',$_REQUEST['page'],'delete',$item['id']),
	        );

	  return sprintf('%1$s %2$s', $item['title'], $this->row_actions($actions) );
	}

	function prepare_items() {
		$per_page = 20;
		$current_page = $this->get_pagenum();

		$data=$this->get_items();

		$total_items = count($data);

		$this->found_data = array_slice($data,(($current_page-1)*$per_page),$per_page);

		$this->set_pagination_args( array(
				    'total_items' => $total_items,                  //WE have to calculate the total number of items
				    'per_page'    => $per_page                     //WE have to determine how many items to show on a page
				  ) );

	  $columns = $this->get_columns();
	  $hidden = array();
	  $sortable = array();
	  $this->_column_headers = array($columns, $hidden, $sortable);
	  $this->items = $this->found_data;
	}

	function column_default( $item, $column_name ) {
	
	  switch( $column_name ) { 
	    case 'title':
	    	return $item[ $column_name ];
	    break;

	    case 'mobile_link':

	    case 'fb_link':
	    	return '<a href="'.$item[ $column_name ].'" target="_blank">'.$item[ $column_name ].'</a>';
	    break;

	    
	    case 'smart_link':
	      return '<a href="'.get_site_url()."/smart_link/".$item[ $column_name ].'" target="_blank">'.get_site_url()."/smart_link/".$item[ $column_name ].'</a>';
	    default:
	      return print_r( $item, true ) ; //Show the whole array for troubleshooting purposes
	  }
	}
}
?>